stages:
  - build
  - package

build-backstage-app:
  stage: build
  image: redhat/ubi9-minimal
  tags:
    - amd64
    - kaniko
  script:
    - microdnf upgrade -y
    - microdnf install -y dnf git python3 python3-pip sqlite-devel gcc-toolset-12
    - dnf module -y reset nodejs
    - dnf module -y enable nodejs:20
    - dnf module -y install nodejs:20/common
    - scl enable gcc-toolset-12 bash
    - npm install -g yarn
    - npm install -g npm@10.6.0
    - npm -v
    - node -v
    - yarn -v
    - echo "backstage" | npx @backstage/create-app@latest
    - cd backstage
    - yarn install --frozen-lockfile
    - yarn tsc
    - yarn build:backend --config ../../app-config.yaml
    - cd ..
    - mkdir ./export
    - cp backstage/app-config*.yaml ./export
    - cp backstage/package.json ./export
    - cp backstage/yarn.lock ./export
    - cp backstage/packages/backend/dist/skeleton.tar.gz ./export
    - cp backstage/packages/backend/dist/bundle.tar.gz ./export
    - cp ./config.json ./export
  artifacts:
    paths:
      - "**/export"
    expire_in: 1 hour

package-container:
  stage: package
  dependencies:
    - build-backstage-app
  tags:
    - amd64
    - kaniko
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  variables: 
    PROJECT_NAME: backstage-docker
    DOCKER_TAG: backstage-node20
  before_script:
    - cp -f "./export/config.json" /kaniko/.docker/config.json
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile Dockerfile-deploy
      --destination ${DOCKER_IO_USER}/${PROJECT_NAME}:${DOCKER_TAG}
      --build-arg USER=node
      --build-arg BACKEND_SECRET=hiDDenPassword
      --cache
  